@layout RootLayout
@inherits LayoutComponentBase
@inject DataService DS
@inject SessionData SD

<Layout Sider="true">
  <LayoutSider>
    <LayoutSiderContent>
      <Bar Breakpoint="Breakpoint.Desktop" NavigationBreakpoint="Breakpoint.Tablet" ThemeContrast="ThemeContrast.Dark"
           Mode="BarMode.VerticalInline" CollapseMode="BarCollapseMode.Small">
        <BarToggler />
        <BarBrand>
          <BarItem>
            <BarLink To="/">
              <BarIcon IconName="customIcon" />
              <div>
                BioMap<br/>
                <Span Style="font-size: 10px;">
                  @this.currentProject
                </Span>
              </div>
            </BarLink>
          </BarItem>
        </BarBrand>
        <BarMenu>
          <BarStart>
            <BarItem>
              <BarDropdown>
                <BarDropdownToggle>
                  <BarIcon IconName="IconName.Map" />
                  @Localize["Maps"]
                </BarDropdownToggle>
                <BarDropdownMenu>
                  <BarDropdownItem To="/Maps/AllElements">
                    @Localize["All Elements"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Maps/Catches">
                    @Localize["Catches"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Maps/Individuals">
                    @Localize["Individuals"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Maps/HeatMapAllElements">
                    Heatmap @Localize["All Elements"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Maps/HeatMapIndividuals">
                    Heatmap @Localize["Individuals"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Maps/HeatMapStays">
                    Heatmap @Localize["Stays"]
                  </BarDropdownItem>
                </BarDropdownMenu>
              </BarDropdown>
            </BarItem>
            <BarItem>
              <BarDropdown>
                <BarDropdownToggle>
                  <BarIcon IconName="IconName.Add" />
                  @Localize["Add"]
                </BarDropdownToggle>
                <BarDropdownMenu>
                  <BarDropdownItem To="/Add/Image">
                    @Localize["Image"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Add/LocElement">
                    @Localize["Located element"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Add/GpxFile">
                    @Localize["GPX file"]
                  </BarDropdownItem>
                </BarDropdownMenu>
              </BarDropdown>
            </BarItem>
            <BarItem>
              <BarDropdown>
                <BarDropdownToggle>
                  <BarIcon IconName="IconName.Forward" />
                  @Localize["Workflow"]
                </BarDropdownToggle>
                <BarDropdownMenu>
                  <BarDropdownItem To="/Workflow/MonitoringCalendar">
                    <BarIcon IconName="IconName.CalendarWeek" />
                    @Localize["Monitoring Calendar"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Workflow/NewElements">
                    <BarIcon IconName="IconName.Inbox" />
                    @Localize["New Elements"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Workflow/Identify">
                    <BarIcon IconName="IconName.IdCard" />
                    @Localize["Identify"]
                  </BarDropdownItem>
                </BarDropdownMenu>
              </BarDropdown>
            </BarItem>
            <BarItem>
              <BarDropdown>
                <BarDropdownToggle>
                  <BarIcon IconName="IconName.List" />
                  @Localize["Lists"]
                </BarDropdownToggle>
                <BarDropdownMenu>
                  <BarDropdownItem To="/Lists/AllElements">
                    @Localize["All Elements"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Lists/AllIndividuals">
                    @Localize["All Individuals"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Lists/Recaptures">
                    @Localize["Recaptures"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Lists/IndividualMigrations">
                    @Localize["Migrations of Individuals"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Lists/Log">
                    @Localize["Log"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Lists/Notes">
                    @Localize["Notes"]
                  </BarDropdownItem>
                </BarDropdownMenu>
              </BarDropdown>
            </BarItem>
            <BarItem>
              <BarDropdown>
                <BarDropdownToggle>
                  <BarIcon IconName="IconName.Images" />
                  @Localize["Pictures"]
                </BarDropdownToggle>
                <BarDropdownMenu>
                  <BarDropdownItem To="/Pictures/AllImages">
                    @Localize["All Images"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Pictures/IdCards">
                    @Localize["ID Cards"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Pictures/PatternImages">
                    @Localize["Pattern images"]
                  </BarDropdownItem>
                </BarDropdownMenu>
              </BarDropdown>
            </BarItem>
            <BarItem>
              <BarDropdown>
                <BarDropdownToggle>
                  <BarIcon IconName="IconName.ChartPie" />
                  @Localize["Statistics"]
                </BarDropdownToggle>
                <BarDropdownMenu>
                  <BarDropdownItem To="/Statistics/Summary">
                    @Localize["Summary"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Statistics/Catches">
                    @Localize["Catches"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Statistics/AgeStructure">
                    @Localize["Age structure"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Statistics/SurvivalRate">
                    @Localize["Survival rate"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Statistics/Reproduction">
                    @Localize["Reproduction"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Statistics/PopulationSize">
                    @Localize["Population size"]
                  </BarDropdownItem>
                  @if (this.SD.CurrentProject.DisplayMass) {
                    <BarDropdownItem To="/Statistics/ConditionIndex">
                      @Localize["Condition index"]
                    </BarDropdownItem>
                  }
                  <BarDropdownItem To="/Statistics/SizeTimeChart">
                    @Localize["Length / Time Chart"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Statistics/FrequencyByPlace">
                    @Localize["Frequency by Place / Time Chart"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Statistics/NumberYoBChart">
                    @Localize["Numbers / Year of Birth Chart"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Statistics/IndividualDev">
                    @Localize["Development"]
                  </BarDropdownItem>
                </BarDropdownMenu>
              </BarDropdown>
            </BarItem>
            <BarItem>
              <BarDropdown>
                <BarDropdownToggle>
                  <BarIcon IconName="IconName.SliderHorizontal" />
                  @Localize["Administration"]
                </BarDropdownToggle>
                <BarDropdownMenu>
                  <BarDropdownItem To="/Administration/UserMgt">
                    <BarIcon IconName="IconName.User" />
                    @Localize["User"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Administration/Places">
                    <BarIcon IconName="IconName.LocationArrow" />
                    @Localize["Places"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Administration/ProjectMgt">
                    <BarIcon IconName="IconName.Shapes" />
                    @Localize["Project"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Administration/Taxa">
                    <BarIcon IconName="IconName.Dog" />
                    @Localize["Taxa"]
                  </BarDropdownItem>
                </BarDropdownMenu>
              </BarDropdown>
            </BarItem>
            <BarItem>
              <BarDropdown>
                <BarDropdownToggle>
                  <BarIcon IconName="IconName.QuestionCircle" />
                  @Localize["Help"]
                </BarDropdownToggle>
                <BarDropdownMenu>
                  <BarDropdownItem To="/Help/About">
                    <BarIcon IconName="IconName.Info" />
                    @Localize["About"]..
                  </BarDropdownItem>
                  <BarDropdownItem Target="Target.Blank" To="/FAQ/FAQ.html">
                    <BarIcon IconName="IconName.QuestionCircle" />
                    FAQ
                  </BarDropdownItem>
                  <BarDropdownDivider />
                  @foreach (var doc in DS.GetDocs(SD.CurrentUser.Project)) {
                    <BarDropdownItem To=@("/api/docs/"+doc.Filename+"?Project="+SD.CurrentUser.Project) Target="Target.Blank">
                      <BarIcon IconName=@((doc.ContentType=="application/pdf"?IconName.FilePdf:IconName.Book)) />
                      @doc.DisplayName
                    </BarDropdownItem>
                  }
                  <BarDropdownDivider />
                  <BarDropdownItem To="/Help/Impressum">
                    <BarIcon IconName="IconName.Book" />
                    @Localize["Impressum"]
                  </BarDropdownItem>
                  <BarDropdownItem To="/Help/DataUsage">
                    <BarIcon IconName="IconName.Book" />
                    @Localize["Data usage"]
                  </BarDropdownItem>
                </BarDropdownMenu>
              </BarDropdown>
            </BarItem>
          </BarStart>
          <BarEnd>
            <BarItem>
              <BarLink To="/Help/Impressum">
                <BarIcon IconName="IconName.Book" />
                @Localize["Impressum"]
              </BarLink>
            </BarItem>
          </BarEnd>
        </BarMenu>
      </Bar>
    </LayoutSiderContent>
  </LayoutSider>
  <Layout>
    <LayoutContent Padding="Padding.Is4.OnX" Style="overflow:hidden">
      @Body
    </LayoutContent>
  </Layout>
</Layout>

@code {
  [CascadingParameter] protected Theme Theme { get; set; }

  RenderFragment customIcon = (x) => { x.AddMarkupContent(0,"<img src=\"/favicon-96x96.png\" style=\"width:32px; height: 32px\" />"); };

  RenderFragment currentProject = (x) => { x.AddMarkupContent(0, ""); };

  protected override async Task OnInitializedAsync() {
    await base.OnInitializedAsync();
    this.currentProject = (x) => { x.AddMarkupContent(0,this.SD.CurrentUser.Project); };
    SD.CurrentProjectChanged += (sender,e) => {
      this.currentProject = (x) => { x.AddMarkupContent(0, this.SD.CurrentUser.Project); };
      this.StateHasChanged();
    };
  }
}
